Site Tools


Differences

This shows you the differences between two versions of the page.

Link to this comparison view

developer:rhinocommonsamples:projectpointstobreps [2015/09/14] (current)
Line 1: Line 1:
 +===== Sample: Projecting Points to Breps =====
 +
 +===== C# =====
 +<code c#>
 +[System.Runtime.InteropServices.Guid("​B4B659D8-DAA0-4970-8149-E4D5C2CF99B7"​)]
 +public class ProjectPointsToBrepsCommand : Command
 +{
 +  public override string EnglishName { get { return "​csProjectPtointsToBreps";​ } }
 +
 +  protected override Result RunCommand(RhinoDoc doc, RunMode mode)
 +  {
 +    var gs = new GetObject();​
 +    gs.SetCommandPrompt("​select surface"​);​
 +    gs.GeometryFilter = ObjectType.Surface | ObjectType.PolysrfFilter;​
 +    gs.DisablePreSelect();​
 +    gs.SubObjectSelect = false;
 +    gs.Get();
 +    if (gs.CommandResult() != Result.Success)
 +      return gs.CommandResult();​
 +    var brep = gs.Object(0).Brep();​
 +    if (brep == null)
 +      return Result.Failure;​
 +
 +    var points = Intersection.ProjectPointsToBreps(
 +                 new List<​Brep>​ {brep}, // brep on which to project
 +                 new List<​Point3d>​ {new Point3d(0, 0, 0), new Point3d(3,​0,​3),​ new Point3d(-2,​0,​-2)},​ // some random points to project
 +                 new Vector3d(0, 1, 0), // project on Y axis
 +                 ​doc.ModelAbsoluteTolerance);​
 +
 +    if (points != null && points.Length > 0)
 +    {
 +      foreach (var point in points)
 +      {
 +        doc.Objects.AddPoint(point);​
 +      }
 +    }
 +    doc.Views.Redraw();​
 +    return Result.Success;​
 +  }
 +}
 +</​code>​
 +===== VB.NET =====
 +<code vb>
 +<​System.Runtime.InteropServices.Guid("​37B8FA8A-DDE2-45C1-AC07-432701C6605C"​)>​ _
 +Public Class ProjectPointsToBrepsCommand
 +  Inherits Command
 +  Public Overrides ReadOnly Property EnglishName() As String
 +    Get
 +      Return "​vbProjectPtointsToBreps"​
 +    End Get
 +  End Property
 +
 +  Protected Overrides Function RunCommand(doc As RhinoDoc, mode As RunMode) As Result
 +    Dim gs = New GetObject()
 +    gs.SetCommandPrompt("​select surface"​)
 +    gs.GeometryFilter = ObjectType.Surface Or ObjectType.PolysrfFilter
 +    gs.DisablePreSelect()
 +    gs.SubObjectSelect = False
 +    gs.[Get]()
 +    If gs.CommandResult() <> Result.Success Then
 +      Return gs.CommandResult()
 +    End If
 +    Dim brep = gs.[Object](0).Brep()
 +    If brep Is Nothing Then
 +      Return Result.Failure
 +    End If
 +
 +    ' brep on which to project
 +    ' some random points to project
 +    ' project on Y axis
 +    Dim points = Intersection.ProjectPointsToBreps(New List(Of Brep)() From { _
 +      brep _
 +    }, New List(Of Point3d)() From { _
 +      New Point3d(0, 0, 0), _
 +      New Point3d(3, 0, 3), _
 +      New Point3d(-2, 0, -2) _
 +    }, New Vector3d(0, 1, 0), doc.ModelAbsoluteTolerance)
 +
 +    If points IsNot Nothing AndAlso points.Length > 0 Then
 +      For Each point As Point3d In points
 +        doc.Objects.AddPoint(point)
 +      Next
 +    End If
 +    doc.Views.Redraw()
 +    Return Result.Success
 +  End Function
 +End Class
 +d Namespace
 +</​code>​
 +===== Python =====
 +<code python>
 +import rhinoscriptsyntax as rs
 +from scriptcontext import *
 +from Rhino.Geometry import *
 +
 +def RunCommand():​
 +  srfid = rs.GetObject("​select surface",​ rs.filter.surface | rs.filter.polysurface)
 +  if not srfid: return
 +  brep = rs.coercebrep(srfid)
 +  if not brep: return
 +  ​
 +  pts = Intersect.Intersection.ProjectPointsToBreps(
 +      [brep], # brep on which to project
 +      [Point3d(0, 0, 0), Point3d(3,​0,​3),​ Point3d(-2,​0,​-2)],​ # points to project
 +      Vector3d(0, 1, 0), # project on Y axis
 +      doc.ModelAbsoluteTolerance)
 +
 +  if pts != None and pts.Length > 0:
 +    for pt in pts:
 +      doc.Objects.AddPoint(pt)
 +
 +  doc.Views.Redraw()
 +
 +if __name__ == "​__main__":​
 +    RunCommand()
 +</​code>​
 +
 +{{tag>​Developer rhinocommon}}
  
developer/rhinocommonsamples/projectpointstobreps.txt ยท Last modified: 2015/09/14 (external edit)